﻿
using AForge.Controls;
using AForge.Video;
using AForge.Video.DirectShow;
using System;
using System.Collections;
using System.Diagnostics;
using System.Drawing;
using System.Threading;
using Wisej.Web;

namespace WebApplication10
{
    public partial class Window1 : Form
    {
        private Stopwatch stopWatch;
        //private VideoSourcePlayer videoSourcePlayer;

        public Window1()
        {
            InitializeComponent();
            //this.videoSourcePlayer = new VideoSourcePlayer();

            //this.panel1.Controls.Add((Control)this.videoSourcePlayer);


            //this.videoSourcePlayer.AutoSizeControl = true;
            //this.videoSourcePlayer.BackColor = SystemColors.ControlDarkDark;
            //this.videoSourcePlayer.ForeColor = Color.White;
            //this.videoSourcePlayer.Location = new Point(56, 33);
            //this.videoSourcePlayer.Name = "videoSourcePlayer";
            //this.videoSourcePlayer.Size = new Size(322, 242);
            //this.videoSourcePlayer.TabIndex = 0;
            //this.videoSourcePlayer.VideoSource = (IVideoSource)null;
            //this.videoSourcePlayer.NewFrame += new VideoSourcePlayer.NewFrameHandler(this.videoSourcePlayer_NewFrame);

        }
        private FilterInfoCollection videoDevices;
        private VideoCaptureDevice FinalVideo;
        public static Bitmap _latestFrame;

        private void Window1_Load(object sender, EventArgs e)
        {
            try
            {
                this.videoDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
                if (this.videoDevices.Count == 0)
                    throw new ApplicationException();
                foreach (FilterInfo videoDevice in (CollectionBase)this.videoDevices)
                    this.devicesCombo.Items.Add((object)videoDevice.Name);
            }
            catch (ApplicationException ex)
            {
                this.devicesCombo.Items.Add((object)"No local capture devices");
                this.devicesCombo.Enabled = false;
                //this.okButton.Enabled = false;
            }
            this.devicesCombo.SelectedIndex = 0;
        }

        private void devicesCombo_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void OpenVideoSource(IVideoSource source)
        {
            this.Cursor = Cursors.WaitCursor;
            this.CloseCurrentVideoSource();
            //this.videoSourcePlayer.VideoSource = source;
            //this.videoSourcePlayer.Start();
            this.stopWatch = (Stopwatch)null;
            // this.timer.Start();
            this.Cursor = Cursors.Default;

            source.NewFrame += Source_NewFrame;

            source.Start();
        }

        private void Source_NewFrame(object sender, NewFrameEventArgs eventArgs)
        {
            Bitmap video = (Bitmap)eventArgs.Frame.Clone();
            pictureBox1.Image = video;
        }

        private void CloseCurrentVideoSource()
        {
            //if (this.videoSourcePlayer.VideoSource == null)
            //    return;
            //this.videoSourcePlayer.SignalToStop();
            //for (int index = 0; index < 30 && this.videoSourcePlayer.IsRunning; ++index)
            //    Thread.Sleep(100);
            //if (this.videoSourcePlayer.IsRunning)
            //    this.videoSourcePlayer.Stop();
            //this.videoSourcePlayer.VideoSource = (IVideoSource)null;
        }

        private void videoSourcePlayer_NewFrame(object sender, ref Bitmap image)
        {
            DateTime now = DateTime.Now;
            Graphics graphics = Graphics.FromImage((Image)image);
            SolidBrush solidBrush = new SolidBrush(Color.Red);
            graphics.DrawString(now.ToString(), this.Font, (Brush)solidBrush, new PointF(5f, 5f));
            solidBrush.Dispose();
            graphics.Dispose();
        }

        private void timer_Tick(object sender, EventArgs e)
        {
           
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string device = this.videoDevices[this.devicesCombo.SelectedIndex].MonikerString;
            FinalVideo = new VideoCaptureDevice(device);
            this.OpenVideoSource((IVideoSource)FinalVideo);

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (FinalVideo.IsRunning)
            {
                FinalVideo.Stop();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //IVideoSource videoSource = this.videoSourcePlayer.VideoSource;
            //if (videoSource == null)
            //    return;
            //int framesReceived = videoSource.FramesReceived;
            //if (this.stopWatch == null)
            //{
            //    this.stopWatch = new Stopwatch();
            //    this.stopWatch.Start();
            //}
            //else
            //{
            //    this.stopWatch.Stop();
            //    this.fpsLabel.Text = (1000f * (float)framesReceived / (float)this.stopWatch.ElapsedMilliseconds).ToString("F2") + " fps";
            //    this.stopWatch.Reset();
            //    this.stopWatch.Start();
            //}
        }
    }
}
